
import java.util.HashMap;
import com.silanis.esl.sdk.DocumentPackage;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.apitoken.ApiTokenConfig;
import com.silanis.esl.sdk.apitoken.ApiTokenConfig.TokenType;
import com.silanis.esl.sdk.builder.DocumentBuilder;
import com.silanis.esl.sdk.builder.PackageBuilder;
import com.silanis.esl.sdk.builder.SignatureBuilder;
import com.silanis.esl.sdk.builder.SignerBuilder;
 
public class SimpleCreateAndSendPackage {
 
//    public static final String API_KEY = "your_api_key";
//    public static final String API_URL = "https://sandbox.esignlive.com/api";  // Use https://apps.esignlive.com/api For Production
 
    //Alternatively
    public static final String CLIENT_APP_ID = "your_client_id";
    public static final String CLIENT_APP_SECRET = "your_client_secret";
    public static final String BASE_API_URL = "https://sandbox.esignlive.com";    // Use https://apps.esignlive.com For Production
    public static final String API_URL = BASE_API_URL + "/api";    
    
    public static void main(String[] args) {
//    	EslClient eslClient = new EslClient(API_KEY, API_URL);
        
        //Alternatively
        EslClient eslClient = new EslClient(ApiTokenConfig.newBuilder()
        		.clientAppId(CLIENT_APP_ID)
        		.clientAppSecret(CLIENT_APP_SECRET)
        		.baseUrl(BASE_API_URL)
        		.tokenType(TokenType.OWNER)
        		.build(), 
        		BASE_API_URL + "/api", false, null, false, new HashMap());
        
        
        // Build the DocumentPackage object
        DocumentPackage documentPackage = PackageBuilder.newPackageNamed("Example Transaction created by Java SDK")
                .withSigner(SignerBuilder.newSignerWithEmail("signers.email@example.com")
                        .withCustomId("Signer")
                        .withFirstName("SignerFirstName")
                        .withLastName("SignerLastName"))
                .withSigner(SignerBuilder.newSignerWithEmail("your.email@example.com")
                        .withFirstName("YourFirstName")
                        .withLastName("YourLastName"))
                .withDocument(DocumentBuilder.newDocumentWithName("sampleAgreement")
                        .fromFile("path_to_your_document")
                        .withSignature(SignatureBuilder.signatureFor("signers.email@example.com")
                                .onPage(0)
                                .atPosition(175, 165))
                        .withSignature(SignatureBuilder.signatureFor("your.email@example.com")
                        		.onPage(0)
                        		.atPosition(550, 165)))
                .build();
 
        // Issue the request to the OneSpan Sign server to create the DocumentPackage
        PackageId packageId = eslClient.createPackageOneStep(documentPackage);
        System.out.println(packageId);
        
        // Send the package to be signed by the participants
        eslClient.sendPackage(packageId);
    }
}